WingzParser Class Reference documentation

WingzParser Class Referencefinal

the main class to read a Claris Resolve or a Wingz document More...

`#include <WingzParser.hxx>`

Inheritance diagram for WingzParser:

## Public Member Functions
| WingzParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~WingzParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface) final
| the main parse function
MWAWVec2f | getPosition (MWAWVec2i const &cell, MWAWVec2f const &relPos) const
| returns the page position corresponding to a cell and its relative position(in percent)
Public Member Functions inherited from MWAWSpreadsheetParser
| ~MWAWSpreadsheetParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document
bool | sendSpreadsheet ()
| try to send the main spreadsheet
bool | createZones ()
| finds the different objects zones
bool | readPrintInfo ()
| read the print info zone
bool | readPreferences ()
| read the preference zone ( the first zone)
bool | readSpreadsheet ()
| read the spreadshet zone
bool | readSpreadsheetSize ()
| read some spreadsheet size (col/row size or page break)
bool | readSpreadsheetPBreak ()
| read a page break zone
bool | readSpreadsheetStyle ()
| read a style in a spreadsheet
bool | readSpreadsheetCellName ()
| read a spreadsheet cell name
bool | readFormula ()
| read a formula in a spreadsheet
bool | readSpreadsheetCellList ()
| read a spreadsheet list of cell
bool | readSpreadsheetZone5 ()
| read a spreadsheet unknown zone 5
bool | readMacro ()
| read a macro in a text zone ( some graphic zone)
bool | decodeEncrypted ()
| try to decode an encrypted input
bool | findNextZone (int lastType=0)
| try to find the next spreadsheet zone
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWSpreadsheetParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< WingzParserInternal::State > | m_state
| the state
std::shared_ptr< WingzGraph > | m_graphParser
| the graph parser

## Friends
class | WingzGraph

## Detailed Description

the main class to read a Claris Resolve or a Wingz document

Note
  need more files to be sure to treat all documents, ie. as some flags (defining the following type's field) can appear in many structures, only having a lot of documents can allow to find all this type's fields...

## Constructor & Destructor Documentation

## ◆ WingzParser()

WingzParser::WingzParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~WingzParser()

WingzParser::~WingzParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool WingzParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse(), and WingzGraph.

## ◆ createDocument()

void WingzParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse(), and WingzGraph.

## ◆ createZones()

bool WingzParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse(), and WingzGraph.

## ◆ decodeEncrypted()

bool WingzParser::decodeEncrypted | ( |  | ) |
| protected

try to decode an encrypted input

Referenced by parse(), and WingzGraph.

## ◆ findNextZone()

bool WingzParser::findNextZone | ( | int | lastType = 0 | ) |
| protected

try to find the next spreadsheet zone

Referenced by createZones(), readSpreadsheet(), and WingzGraph.

## ◆ getPosition()

MWAWVec2f WingzParser::getPosition | ( | MWAWVec2i const & | cell,
|  | MWAWVec2f const & | relPos ) const

returns the page position corresponding to a cell and its relative position(in percent)

Referenced by WingzGraph.

## ◆ init()

void WingzParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by WingzGraph, and WingzParser().

## ◆ parse()

void WingzParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| finalvirtual

the main parse function

Implements MWAWSpreadsheetParser.

Referenced by WingzGraph.

## ◆ readFormula()

bool WingzParser::readFormula | ( |  | ) |
| protected

read a formula in a spreadsheet

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readMacro()

bool WingzParser::readMacro | ( |  | ) |
| protected

read a macro in a text zone ( some graphic zone)

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readPreferences()

bool WingzParser::readPreferences | ( |  | ) |
| protected

read the preference zone ( the first zone)

Referenced by createZones(), and WingzGraph.

## ◆ readPrintInfo()

bool WingzParser::readPrintInfo | ( |  | ) |
| protected

read the print info zone

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readSpreadsheet()

bool WingzParser::readSpreadsheet | ( |  | ) |
| protected

read the spreadshet zone

Referenced by createZones(), and WingzGraph.

## ◆ readSpreadsheetCellList()

bool WingzParser::readSpreadsheetCellList | ( |  | ) |
| protected

read a spreadsheet list of cell

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readSpreadsheetCellName()

bool WingzParser::readSpreadsheetCellName | ( |  | ) |
| protected

read a spreadsheet cell name

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readSpreadsheetPBreak()

bool WingzParser::readSpreadsheetPBreak | ( |  | ) |
| protected

read a page break zone

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readSpreadsheetSize()

bool WingzParser::readSpreadsheetSize | ( |  | ) |
| protected

read some spreadsheet size (col/row size or page break)

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readSpreadsheetStyle()

bool WingzParser::readSpreadsheetStyle | ( |  | ) |
| protected

read a style in a spreadsheet

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ readSpreadsheetZone5()

bool WingzParser::readSpreadsheetZone5 | ( |  | ) |
| protected

read a spreadsheet unknown zone 5

Referenced by readSpreadsheet(), and WingzGraph.

## ◆ sendSpreadsheet()

bool WingzParser::sendSpreadsheet | ( |  | ) |
| protected

try to send the main spreadsheet

Referenced by parse(), and WingzGraph.

## Friends And Related Symbol Documentation

## ◆ WingzGraph

friend class WingzGraph
| friend

Referenced by WingzGraph, and WingzParser().

## Member Data Documentation

## ◆ m_graphParser

std::shared_ptr<WingzGraph> WingzParser::m_graphParser
| protected

the graph parser

Referenced by readSpreadsheet(), sendSpreadsheet(), and WingzParser().

## ◆ m_state

std::shared_ptr<WingzParserInternal::State> WingzParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), getPosition(), init(), parse(), readFormula(), readSpreadsheetCellList(), readSpreadsheetCellName(), readSpreadsheetSize(), readSpreadsheetStyle(), sendSpreadsheet(), and WingzParser().

The documentation for this class was generated from the following files:

- WingzParser.hxx
- WingzParser.cxx